#!/usr/bin/perl

$provider = $ARGV[0];

if('' eq $provider){
    print "Usage: airhd.pl <provider>\n";
    exit(0);
}

@cfg_files = glob '/etc/sysconfig/network-scripts/ifcfg-ppp*';

open(FH,"grep -s -l -w \"$provider\" @cfg_files|");
$ppp_file = <FH>;
close(FH);
chomp($ppp_file);
$ppp_file =~ /(ppp\d+)/;
$ppp_dev = $1;
if('' eq $ppp_dev){
    print "PPP device not found.\n";
    exit(0);
}

# CONST

$pppd_pidfile = "/var/run/ppp-$ppp_dev.pid";
$wvdiallog = "/var/log/messages";	# wvdial
$watch_interval = 60;			# Watch interval 60 sec.
$redial_interval = 60*2+30;		# Redial interval 150 sec.
$outrange_interval = 60*5;		# Out of range intervarl 300 sec.
$out_mul = 1;				#
$CardH = "AH-G10";			# AirH" Card ident.
$Ant_SH = 20;				# Antenna Level sleshold.
$tty_default = 'ttyS1';


$SIG{'KILL'} = 'terminate_proc';
$SIG{'INT'}  = 'terminate_proc';
$SIG{'QUIT'} = 'terminate_proc';

if($child = fork){
  # Main process.

  my($antLv);

#  open(LOG1, '>/tmp/airhlog1.txt') || die $!;
#  select(LOG1); $|=1; select(STDOUT);

  while( 1 ){
    $card_socket = check_card($CardH);
    if(0 <= $card_socket){ # cardctl identAirH"ɤ뤫ǧ
      if(!open(FH,"$pppd_pidfile")){
#	WriteLog('ppp_terminate()');
	ppp_terminate();
	$antLv = GetAntennaLevel();
	if( ($Ant_SH <= $antLv)||($antLv < 0) ){
	  system("/sbin/ifup $ppp_dev");
#	  WriteLog("AntennaLevel = $antLv OK, ifup $ppp_dev");
	  $out_mul = 1;
	}else{
	  system("/sbin/cardctl eject $card_socket");
#	  WriteLog("AntennaLevel = $antLv LOW, card eject $card_socket");
	  # ƥʥ٥Ͱʲ⸡Ф줿
	  # åֳ֤ϤɤɤӤ롣60ʬֳ
	  sleep($outrange_interval * $out_mul);
	  system("/sbin/cardctl insert $card_socket");
#	  WriteLog("AntennaLevel = $antLv LOW, card insert $card_socket");
	  if(12>$out_mul){
	    $out_mul++;
	  }
	}
      }
      else{
	$pppd_pid = <FH>;
	close(FH);
	chomp($pppd_pid);
	open(FH,"ps $pppd_pid|grep pppd|");
	$stat = <FH>;
	close(FH);
	chomp($stat);
	if('' eq $stat){
#	  WriteLog("pppd dead. ifup $ppp_dev");
	  unlink("$pppd_pidfile");
	  system("/sbin/ifup $ppp_dev");
	}
      }
    }
    sleep($watch_interval);
  }
}
else{
  # Child process.
#  open(LOG2, '>/tmp/airhlog2.txt') || die $!;
#  select(LOG2); $|=1; select(STDOUT);
  open(WVDIAL, "<$wvdiallog") || die("Can't open $wvdiallog.");
  seek(WVDIAL, 0, 2);  # EOF(ե)

  while( 1 ){
    $wvdial_stat = readlog();
    $card_socket = check_card($CardH);

    if('DELAYED ' eq $wvdial_stat){
      # 뵬˰ääPCMCIAejectǡ
      # ᥤץ˥ǥǧʤ褦ˤ롣
      # ɡӤäʤΤŸߤ롣
      if(0 <= $card_socket){
	system("/sbin/cardctl eject $card_socket");
#	WriteLog2("DELAYD card eject $card_socket");
	ppp_terminate();
	sleep($redial_interval);
	system("/sbin/cardctl insert $card_socket");
#	WriteLog2("DELAYD card eject $card_socket");
	# ᥤץidentȤСᥤץ
	# 򤪤ʤ
      }
    }
    # ɤޤäƤơıʤϥɤꥻå
    if((0 <= $card_socket)&&('Modem not responding. ' eq $wvdial_stat)){
      system("/sbin/cardctl reset $card_socket");
#      WriteLog2("card reset  $card_socket");
    }
    sleep(1);
  }
  exit(0);
}

# ʸPCMCIA ɤSocketֹ
# ˸դäΤΤߤ֤
sub check_card {
  my($ident) = @_;
  my($card_num) = -1;
  my($tmp);

  open(FH,'/sbin/cardctl ident|');
  while( $result = <FH> ){
    chomp($result);
    if($result =~ /^Socket\s+(\d+):/){
      $tmp = $1;
    }
    if($result =~ /$ident/){
      $card_num = $tmp;
      last;
    }
  }
  close(FH);
  return($card_num);
}

sub readlog {
  my($line,$result,$dummy);

  $result = '';

  if($line = <WVDIAL>) {
    if($line =~ /WvDial:/){
      ($dummy,$result) = split('WvDial: ',$line);
      chomp($result);
    }
  }
  return($result);
}

sub ppp_terminate {
  my($pppd_pid,$tty) = ('','');

  # pppd  pid  tty μ
  if(open(BB,"$pppd_pidfile")){
    $pppd_pid = <BB>;
    close(BB);
    chomp($pppd_pid);
    if('' ne $pppd_pid){
      open(BB,"/bin/ps $pppd_pid|/bin/grep pppd|");
      $line = <BB>;
      close(BB);
      chomp($line);
      $line =~ /(ttyS\d+)/;
      $tty = $1;
    }
    if('' eq $tty){
      $tty = $tty_default;
    }
  }
  system("/sbin/ifdown $ppp_dev >/dev/null 2>&1");

  # ǰΤθ
  if('' ne $pppd_pid){
    system("/bin/kill -KILL $pppd_pid >/dev/null 2>&1");
  }
  system('/usr/bin/killall -KILL wvdial >/dev/null 2>&1');
  unlink("/var/lock/LCK\.\.$tty");
  unlink("$pppd_pidfile");

  return;
}

sub GetAntennaLevel {
  my($tty,$tty_dev,$dum);
  my($line,$CS,$AntennaLevel);
  my(@results);

  return(-1); 
 
  system('stty -F /dev/modem clocal -echo -tostop');
  $tty = readlink('/dev/modem') || die $!;
  ($dum,$dum,$tty_dev) =  split('/',$tty);

  # ˥åƤ
  if(open(FH,"/var/lock/LCK..$tty_dev")){
    close(FH);
    return(-1);
  }
  # åե
  open(FH,">/var/lock/LCK..$tty_dev") || die $!;
  print FH "$$";
  close(FH);

  open(FH,'+>/dev/modem') || die $!;

  print FH "AT#Q1\r";
  do{
    $line = <FH>;
    $line =~ s/[\x0d\x0a]+$//;
    if('' ne $line){
      push(@results,$line);
    }
  } until ( ('OK' eq $line) || ('ERROR' eq $line ) );

  $AntennaLevel = 0;

  if('OK' eq $line){
    ($CS,$AntennaLevel) = split(',',$results[1]);
  }
  if('' eq $AntennaLevel){
    $AntennaLevel = 0;
  }
  close(FH);
  unlink("/var/lock/LCK..$tty_dev");
  return($AntennaLevel);
}

sub terminate_proc {
  if($child){
    kill 9,$child;
  }
  close(WVDIAL);
#  close(LOG1);
#  close(LOG2);
}

sub WriteLog {
  my ($str) = @_;
  my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
  $year += 1900;
  my @Mon = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
  my @Day = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

  print LOG1 sprintf("%4d/%02d/%02d %02d:%02d:%02d ",$year,$mon+1,$mday,$hour,$min,$sec)."$str\n";
  return;

}

sub WriteLog2 {
  my ($str) = @_;
  my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
  $year += 1900;
  my @Mon = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
  my @Day = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

  print LOG2 sprintf("%4d/%02d/%02d %02d:%02d:%02d ",$year,$mon+1,$mday,$hour,$min,$sec)."$str\n";
  return;

}
